# ArrayInterface.jl

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://docs.sciml.ai/ArrayInterface/stable/)
[![CI](https://github.com/JuliaArrays/ArrayInterface.jl/workflows/CI/badge.svg)](https://github.com/JuliaArrays/ArrayInterface.jl/actions?query=workflow%3ACI)
[![Build status](https://badge.buildkite.com/a2db252d92478e1d7196ee7454004efdfb6ab59496cbac91a2.svg?branch=master)](https://buildkite.com/julialang/arrayinterface-dot-jl)
[![codecov](https://codecov.io/gh/JuliaArrays/ArrayInterface.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaArrays/ArrayInterface.jl)

The AbstractArray interface in Base Julia is still relatively young.
The purpose of this library is to solidify extensions to the current
AbstractArray interface, which are put to use in package ecosystems like
DifferentialEquations.jl. Since these libraries are live, this package will
serve as a staging ground for ideas before they are merged into Base Julia. For this
reason, no functionality is exported so that if such functions are added
and exported in a future Base Julia, there will be no issues with the upgrade.

# List of things to add

- https://github.com/JuliaLang/julia/issues/22216
- https://github.com/JuliaLang/julia/issues/22218
- https://github.com/JuliaLang/julia/issues/22622
- https://github.com/JuliaLang/julia/issues/25760
- https://github.com/JuliaLang/julia/issues/25107

# Array Types to Handle

The following common array types are being understood and tested as part of this
development.

- Array
- Various versions of sparse arrays
- SArray
- MArray
- FieldVector
- ArrayPartition
- VectorOfArray
- DistributedArrays
- GPUArrays (CLArrays and CuArrays)
- AFArrays
- MultiScaleArrays
- LabelledArrays

## StaticArrayInterface.jl

If one is looking for an interface which includes functionality for statically-computed values, see [StaticArrayInterface.jl](https://github.com/JuliaArrays/StaticArrayInterface.jl).
This was separated from ArrayInterface.jl because it includes a lot of functionality that does not give substantive improvements
to the interface, and is likely to be deprecated in the near future as the compiler matures to automate a lot of its optimizations.

## Breaking Release Notes

7.0: Setup to use the new v1.9 package extensions. All static interface functions were moved to
[StaticArrayInterface.jl](https://github.com/JuliaArrays/StaticArrayInterface.jl). All packages
using one of the subpackages (ArrayInterfaceCore, ArrayInterfaceStaticArrays, etc.) should
update to v7 by simply depending on ArrayInterface.jl, unless static interface functions
were used in which case a dependency on StaticArrayInterface.jl is also necessary.

6.0: ArrayInterface.jl completely removed all usage of Requires.jl and conditional dependencies
due to compile time impact. All of the Requires.jl support changed to subpackages within the
repository which are registered in the General registry. These subpackages are required by
any packages which seek to use the additional functionality.

2.0: Changed the default of `ismutable(array::AbstractArray) = true`. We previously defaulted to
`Base.@pure ismutable(array::AbstractArray) = typeof(array).mutable`, but there are a lot of cases
where this tends to not work out in a way one would expect. For example, if you put a normal array
into an immutable struct that adds more information to it, this is considered immutable, even if
all of the `setindex!` methods work (by forwarding to the mutable array). Thus, it seems safer to just
always assume mutability is standard for an array, and allow arrays to opt-out.

module ArrayInterfaceChainRulesCoreExt

import ArrayInterface
import ChainRulesCore
import ChainRulesCore: unthunk, NoTangent, ZeroTangent, ProjectTo, @thunk

function ChainRulesCore.rrule(::typeof(ArrayInterface.restructure), target, src)
    projectT = ProjectTo(target)
    function restructure_pullback(dt)
        dt = unthunk(dt)

        f̄ = NoTangent()
        t̄ = ZeroTangent()
        s̄ = @thunk(projectT(ArrayInterface.restructure(src, dt)))

        f̄, t̄, s̄
    end

    return ArrayInterface.restructure(target, src), restructure_pullback
end

end

module ArrayInterfaceReverseDiffExt

using ArrayInterface
import ReverseDiff

ArrayInterface.ismutable(::Type{<:ReverseDiff.TrackedArray}) = false
ArrayInterface.ismutable(T::Type{<:ReverseDiff.TrackedReal}) = false
ArrayInterface.can_setindex(::Type{<:ReverseDiff.TrackedArray}) = false
ArrayInterface.fast_scalar_indexing(::Type{<:ReverseDiff.TrackedArray}) = false
function ArrayInterface.aos_to_soa(x::AbstractArray{<:ReverseDiff.TrackedReal, N}) where {N}
    y = length(x) > 1 ? reduce(vcat, x) : reduce(vcat, [x[1], x[1]])[1:1]
    return reshape(y, size(x))
end

function ArrayInterface.restructure(x::Array, y::ReverseDiff.TrackedArray)
    reshape(y, Base.size(x)...)
end

end # module

module ArrayInterfaceBandedMatricesExt

using ArrayInterface
using ArrayInterface: BandedMatrixIndex
using BandedMatrices
using LinearAlgebra

const TransOrAdjBandedMatrix = Union{
    Adjoint{T, <:BandedMatrix{T}},
    Transpose{T, <:BandedMatrix{T}},
} where {T}

const AllBandedMatrix = Union{
    BandedMatrix{T},
    TransOrAdjBandedMatrix{T},
} where {T}

Base.firstindex(i::BandedMatrixIndex) = 1
Base.lastindex(i::BandedMatrixIndex) = i.count
Base.length(i::BandedMatrixIndex) = lastindex(i)
Base.@propagate_inbounds function Base.getindex(ind::BandedMatrixIndex, i::Int)
    @boundscheck 1 <= i <= ind.count || throw(BoundsError(ind, i))
    _i = i
    p = 1
    while _i - ind.bandsizes[p] > 0
        _i -= ind.bandsizes[p]
        p += 1
    end
    bandind = ind.bandinds[p]
    startfromone = !xor(ind.isrow, (bandind > 0))
    if startfromone
        return _i
    else
        return _i + abs(bandind)
    end
end

function _bandsize(bandind, rowsize, colsize)
    -(rowsize - 1) <= bandind <= colsize - 1 || throw(ErrorException("Invalid Bandind"))
    if (bandind * (colsize - rowsize) > 0) & (abs(bandind) <= abs(colsize - rowsize))
        return min(rowsize, colsize)
    elseif bandind * (colsize - rowsize) <= 0
        return min(rowsize, colsize) - abs(bandind)
    else
        return min(rowsize, colsize) - abs(bandind) + abs(colsize - rowsize)
    end
end

function ArrayInterface.BandedMatrixIndex(rowsize, colsize, lowerbandwidth, upperbandwidth, isrow)
    upperbandwidth > -lowerbandwidth || throw(ErrorException("Invalid Bandwidths"))
    bandinds = upperbandwidth:-1:(-lowerbandwidth)
    bandsizes = [_bandsize(band, rowsize, colsize) for band in bandinds]
    BandedMatrixIndex(sum(bandsizes), rowsize, colsize, bandinds, bandsizes, isrow)
end

function ArrayInterface.findstructralnz(x::AllBandedMatrix)
    l, u = BandedMatrices.bandwidths(x)
    rowsize, colsize = Base.size(x)
    rowind = BandedMatrixIndex(rowsize, colsize, l, u, true)
    colind = BandedMatrixIndex(rowsize, colsize, l, u, false)
    return (rowind, colind)
end

ArrayInterface.has_sparsestruct(::Type{<:AllBandedMatrix}) = true
ArrayInterface.isstructured(::Type{<:AllBandedMatrix}) = true
ArrayInterface.fast_matrix_colors(::Type{<:AllBandedMatrix}) = true

function ArrayInterface.matrix_colors(A::AllBandedMatrix)
    l, u = BandedMatrices.bandwidths(A)
    width = u + l + 1
    return ArrayInterface._cycle(1:width, Base.size(A, 2))
end

end # module

module ArrayInterfaceStaticArraysCoreExt

import ArrayInterface
using LinearAlgebra
import StaticArraysCore: SArray, SMatrix, SVector, StaticMatrix, StaticArray, SizedArray, MArray, MMatrix

function ArrayInterface.undefmatrix(::MArray{S, T, N, L}) where {S, T, N, L}
    return MMatrix{L, L, T, L*L}(undef)
end
# SArray doesn't have an undef constructor and is going to be small enough that this is fine.
function ArrayInterface.undefmatrix(s::SArray)
    v = vec(s)
    return v.*v'
end

ArrayInterface.ismutable(::Type{<:StaticArray}) = false
ArrayInterface.ismutable(::Type{<:MArray}) = true
ArrayInterface.ismutable(::Type{<:SizedArray}) = true

ArrayInterface.can_setindex(::Type{<:StaticArray}) = false
ArrayInterface.can_setindex(::Type{<:MArray}) = true
ArrayInterface.buffer(A::Union{SArray, MArray}) = getfield(A, :data)

function ArrayInterface.lu_instance(A::StaticMatrix{N,N}) where {N}
    lu(one(A))
end

ArrayInterface.restructure(x::SArray{S}, y) where {S} = SArray{S}(y)

end

using ArrayInterface
using ArrayInterface: zeromatrix, undefmatrix
import ArrayInterface: has_sparsestruct, findstructralnz, fast_scalar_indexing, lu_instance,
        parent_type, zeromatrix
using ComponentArrays
using LinearAlgebra
using Random
using SparseArrays
using Test

# ensure we are correctly parsing these
ArrayInterface.@assume_effects :total foo(x::Bool) = x
ArrayInterface.@assume_effects bar(x::Bool) = x
@test foo(true)
@test bar(true)

@testset "zeromatrix and unsafematrix" begin
    for T in (Int, Float32, Float64)
        for (vectype, mattype) in ((Vector{T}, Matrix{T}), (SparseVector{T}, SparseMatrixCSC{T, Int}))
            v = vectype(rand(T, 4))
            um = undefmatrix(v)
            @test size(um) == (length(v),length(v))
            @test typeof(um) == mattype
            @test zeromatrix(v) == zeros(T,length(v),length(v))
        end
        v = rand(T,4,4,4)
        um = undefmatrix(v)
        @test size(um) == (length(v),length(v))
        @test typeof(um) == Matrix{T}
        @test zeromatrix(v) == zeros(T,4*4*4,4*4*4)
        @test zeromatrix(rand(T)) == zero(T)
        @test undefmatrix(rand(T)) isa T
    end
end

@testset "matrix colors" begin
    @test ArrayInterface.fast_matrix_colors(1) == false
    @test ArrayInterface.fast_matrix_colors(Diagonal{Int,Vector{Int}})

    @test ArrayInterface.matrix_colors(Diagonal([1,2,3,4])) == [1, 1, 1, 1]
    @test ArrayInterface.matrix_colors(Bidiagonal([1,2,3,4], [7,8,9], :U)) == [1, 2, 1, 2]
    @test ArrayInterface.matrix_colors(Tridiagonal([1,2,3],[1,2,3,4],[4,5,6])) == [1, 2, 3, 1]
    @test ArrayInterface.matrix_colors(SymTridiagonal([1,2,3,4],[5,6,7])) == [1, 2, 3, 1]
    @test ArrayInterface.matrix_colors(rand(4,4)) == Base.OneTo(4)
end

@testset "parent_type" begin
    x = ones(4, 4)
    @test parent_type(view(x, 1:2, 1:2)) <: typeof(x)
    @test parent_type(reshape(x, 2, :)) <: typeof(x)
    @test parent_type(transpose(x)) <: typeof(x)
    @test parent_type(Symmetric(x)) <: typeof(x)
    @test parent_type(UpperTriangular(x)) <: typeof(x)
    @test parent_type(PermutedDimsArray(x, (2,1))) <: typeof(x)
    @test parent_type(Base.Slice(1:10)) <: UnitRange{Int}
    @test parent_type(Diagonal{Int,Vector{Int}}) <: Vector{Int}
    @test parent_type(UpperTriangular{Int,Matrix{Int}}) <: Matrix{Int}
    @test parent_type(LowerTriangular{Int,Matrix{Int}}) <: Matrix{Int}
end

@testset "buffer" begin
    @test ArrayInterface.buffer(sparse([1,2,3],[1,2,3],[1,2,3])) == [1, 2, 3]
    @test ArrayInterface.buffer(sparsevec([1, 2, 0, 0, 3, 0])) == [1, 2, 3]
    @test ArrayInterface.buffer(Diagonal([1,2,3])) == [1, 2, 3]
end

@test ArrayInterface.can_avx(ArrayInterface.can_avx) == false

@testset "lu_instance" begin
    A = randn(5, 5)
    @test lu_instance(A) isa typeof(lu(A))
    A = sprand(50, 50, 0.5)
    @test lu_instance(A) isa typeof(lu(A))
    @test lu_instance(1) === 1

    @test lu_instance(Symmetric(rand(3,3))) isa typeof(lu(Symmetric(rand(4,4))))
    @test lu_instance(Tridiagonal(rand(3),rand(4),rand(3))) isa typeof(lu(Tridiagonal(rand(3),rand(4),rand(3))))
    @test lu_instance(SymTridiagonal(rand(4),rand(3))) isa typeof(lu(SymTridiagonal(rand(4),rand(3))))
    @test lu_instance(Diagonal(rand(4))) isa typeof(lu(Diagonal(rand(4))))
end

@testset "ismutable" begin
    @test ArrayInterface.ismutable(rand(3))
    @test ArrayInterface.ismutable((0.1,1.0)) == false
    @test ArrayInterface.ismutable(Base.ImmutableDict{Symbol,Int64}) == false
    @test ArrayInterface.ismutable((;x=1)) == false
    @test ArrayInterface.ismutable(UnitRange{Int}) == false
    @test ArrayInterface.ismutable(Dict{Any,Any})
    @test ArrayInterface.ismutable(spzeros(1, 1))
    @test ArrayInterface.ismutable(spzeros(1))
end

@testset "can_change_size" begin
    @test ArrayInterface.can_change_size([1])
    @test ArrayInterface.can_change_size(Vector{Int})
    @test ArrayInterface.can_change_size(Dict{Symbol,Any})
    @test !ArrayInterface.can_change_size(Base.ImmutableDict{Symbol,Int64})
    @test !ArrayInterface.can_change_size(Tuple{})
end

@testset "can_setindex" begin
    @test !@inferred(ArrayInterface.can_setindex(1:2))
    @test @inferred(ArrayInterface.can_setindex(Vector{Int}))
    @test !@inferred(ArrayInterface.can_setindex(UnitRange{Int}))
    @test !@inferred(ArrayInterface.can_setindex(Base.ImmutableDict{Int,Int}))
    @test !@inferred(ArrayInterface.can_setindex(Tuple{}))
    @test !@inferred(ArrayInterface.can_setindex(NamedTuple{(),Tuple{}}))
    @test @inferred(ArrayInterface.can_setindex(Dict{Int,Int}))
end

@testset "fast_scalar_indexing" begin
    @test !fast_scalar_indexing(qr(rand(10, 10)).Q)
    if VERSION >= v"1.7"
        @test !fast_scalar_indexing(qr(rand(10, 10), ColumnNorm()).Q)
    else
        @test !fast_scalar_indexing(qr(rand(10, 10), Val(true)).Q)
    end
    @test !fast_scalar_indexing(lq(rand(10, 10)).Q)
    @test fast_scalar_indexing(Nothing)  # test default
end

@testset "isstructured" begin
    Sp=sparse([1,2,3],[1,2,3],[1,2,3])
    @test has_sparsestruct(Sp)
    rowind,colind=findstructralnz(Sp)
    @test [Tridiagonal([1,2,3],[1,2,3,4],[4,5,6])[rowind[i],colind[i]] for i in 1:length(rowind)]==[1,2,3]
end

@testset "restructure" begin
    x = rand(Float32, 2, 2)
    y = rand(4)
    yr = ArrayInterface.restructure(x, y)
    @test yr isa Matrix{Float64}
    @test size(yr) == (2,2)
    @test vec(yr) == vec(y)

    @testset "views" begin
        x = @view rand(4)[1:2]
        y = rand(2)
        yr = ArrayInterface.restructure(x, y)
        @test yr isa Vector{Float64}
        @test size(yr) == (2,)
        @test yr == y

        x = @view rand(4,4)[1:2,1:2]
        y = rand(2,2)
        yr = ArrayInterface.restructure(x, y)
        @test yr isa Matrix{Float64}
        @test size(yr) == (2,2)
        @test yr == y


        x = @view rand(4,4)[1]
        y = @view rand(2,2)[1]
        yr = ArrayInterface.restructure(x, y)
        @test yr isa Array{Float64,0}
        @test size(yr) == ()
        @test yr == y
    end
end

@testset "isstructured" begin
    @test !@inferred(ArrayInterface.isstructured(Matrix{Int}))  # default
    @test @inferred(ArrayInterface.isstructured(Hermitian{Complex{Int64}, Matrix{Complex{Int64}}}))
    @test @inferred(ArrayInterface.isstructured(Symmetric{Int,Matrix{Int}}))
    @test @inferred(ArrayInterface.isstructured(LowerTriangular{Int,Matrix{Int}}))
    @test @inferred(ArrayInterface.isstructured(UpperTriangular{Int,Matrix{Int}}))
    @test @inferred(ArrayInterface.isstructured(Diagonal{Int64, Vector{Int64}}))
    @test @inferred(ArrayInterface.isstructured(Bidiagonal{Int64, Vector{Int64}}))
    @test @inferred(ArrayInterface.isstructured(Tridiagonal([1,2,3],[1,2,3,4],[4,5,6])))
    @test @inferred(ArrayInterface.isstructured(SymTridiagonal{Int64, Vector{Int64}}))
end

@testset "ArrayInterface.issingular" begin
    for T in [Float64, ComplexF64]
        R = randn(MersenneTwister(2), T, 5, 5)
        S = Symmetric(R)
        L = UpperTriangular(R)
        U = LowerTriangular(R)
        @test all(!ArrayInterface.issingular, [R, S, L, U, U'])
        R[:, 2] .= 0
        @test all(ArrayInterface.issingular, [R, L, U, U'])
        @test !ArrayInterface.issingular(S)
        R[2, :] .= 0
        @test ArrayInterface.issingular(S)
        @test all(!ArrayInterface.issingular, [UnitLowerTriangular(R), UnitUpperTriangular(R), UnitUpperTriangular(R)'])
    end
    @test !@inferred(ArrayInterface.issingular(Diagonal([1,2,3,4])))
    @test @inferred(ArrayInterface.issingular(UniformScaling(0)))
    @test !@inferred(ArrayInterface.issingular(Bidiagonal([1,2,3,4], [7,8,9], :U)))
    @test !@inferred(ArrayInterface.issingular(SymTridiagonal([1,2,3,4],[5,6,7])))
    @test !@inferred(ArrayInterface.issingular(Tridiagonal([1,2,3],[1,2,3,4],[4,5,6])))
end

@testset "Sparsity Structure" begin
    D=Diagonal([1,2,3,4])
    @test has_sparsestruct(D)
    rowind,colind=findstructralnz(D)
    @test [D[rowind[i],colind[i]] for i in 1:length(rowind)]==[1,2,3,4]
    @test length(rowind)==4
    @test length(rowind)==length(colind)

    Bu = Bidiagonal([1,2,3,4], [7,8,9], :U)
    @test has_sparsestruct(Bu)
    rowind,colind=findstructralnz(Bu)
    @test [Bu[rowind[i],colind[i]] for i in 1:length(rowind)]==[1,7,2,8,3,9,4]
    Bl = Bidiagonal([1,2,3,4], [7,8,9], :L)
    @test has_sparsestruct(Bl)
    rowind,colind=findstructralnz(Bl)
    @test [Bl[rowind[i],colind[i]] for i in 1:length(rowind)]==[1,7,2,8,3,9,4]

    Tri=Tridiagonal([1,2,3],[1,2,3,4],[4,5,6])
    @test has_sparsestruct(Tri)
    rowind,colind=findstructralnz(Tri)
    @test [Tri[rowind[i],colind[i]] for i in 1:length(rowind)]==[1,2,3,4,4,5,6,1,2,3]

    STri=SymTridiagonal([1,2,3,4],[5,6,7])
    @test has_sparsestruct(STri)
    rowind,colind=findstructralnz(STri)
    @test [STri[rowind[i],colind[i]] for i in 1:length(rowind)]==[1,2,3,4,5,6,7,5,6,7]
end

@testset "ndims_index" begin
    @test @inferred(ArrayInterface.ndims_index(CartesianIndices(()))) == 1
    @test @inferred(ArrayInterface.ndims_index(trues(2, 2))) == 2
    @test @inferred(ArrayInterface.ndims_index(CartesianIndex(2,2))) == 2
    @test @inferred(ArrayInterface.ndims_index(1)) == 1
end

@testset "ndims_shape" begin
    @test @inferred(ArrayInterface.ndims_shape(1)) === 0
    @test @inferred(ArrayInterface.ndims_shape(:)) === 1
    @test @inferred(ArrayInterface.ndims_shape(CartesianIndex(1, 2))) === 0
    @test @inferred(ArrayInterface.ndims_shape(CartesianIndices((2,2)))) === 2
    @test @inferred(ArrayInterface.ndims_shape([1 1])) === 2
end

@testset "indices_do_not_alias" begin
  @test ArrayInterface.instances_do_not_alias(Float64)
  @test !ArrayInterface.instances_do_not_alias(Matrix{Float64})
  @test ArrayInterface.indices_do_not_alias(Matrix{Float64})
  @test !ArrayInterface.indices_do_not_alias(BitMatrix)
  @test !ArrayInterface.indices_do_not_alias(Matrix{Matrix{Float64}})
  @test ArrayInterface.indices_do_not_alias(Adjoint{Float64,Matrix{Float64}})
  @test ArrayInterface.indices_do_not_alias(Transpose{Float64,Matrix{Float64}})
  @test ArrayInterface.indices_do_not_alias(typeof(view(rand(4,4)', 2:3, 1:2)))
  @test ArrayInterface.indices_do_not_alias(typeof(view(rand(4,4,4), CartesianIndex(1,2), 2:3)))
  @test ArrayInterface.indices_do_not_alias(typeof(view(rand(4,4)', 1:2, 2)))
  @test !ArrayInterface.indices_do_not_alias(typeof(view(rand(7),ones(Int,7))))
  @test !ArrayInterface.indices_do_not_alias(Adjoint{Matrix{Float64},Matrix{Matrix{Float64}}})
  @test !ArrayInterface.indices_do_not_alias(Transpose{Matrix{Float64},Matrix{Matrix{Float64}}})
  @test !ArrayInterface.indices_do_not_alias(typeof(view(fill(rand(4,4),4,4)', 2:3, 1:2)))
  @test !ArrayInterface.indices_do_not_alias(typeof(view(rand(4,4)', StepRangeLen(1,0,5), 1:2)))
end

@testset "ensures_all_unique" begin
    @test ArrayInterface.ensures_all_unique(BitSet())
    @test !ArrayInterface.ensures_all_unique([])
    @test ArrayInterface.ensures_all_unique(1:10)
    @test !ArrayInterface.ensures_all_unique(LinRange(1, 1, 10))
end

@testset "ensures_sorted" begin
    @test ArrayInterface.ensures_sorted(BitSet())
    @test !ArrayInterface.ensures_sorted([])
    @test ArrayInterface.ensures_sorted(1:10)
end

@testset "linearalgebra instances" begin
    for A in [rand(2,2), rand(Float32,2,2), rand(BigFloat,2,2), rand(ComplexF32,2,2), rand(ComplexF64,2,2)]
        
        @test ArrayInterface.lu_instance(A) isa typeof(lu(A))
        @test ArrayInterface.qr_instance(A) isa typeof(qr(A))

        if !(eltype(A) <: BigFloat)
            @test ArrayInterface.cholesky_instance(A' * A) isa typeof(cholesky(A' * A))
            @test ArrayInterface.svd_instance(A) isa typeof(svd(A))
            if !(eltype(A) <: Union{ComplexF16,ComplexF32,ComplexF64})
                @test ArrayInterface.bunchkaufman_instance(A' * A) isa typeof(bunchkaufman(A' * A))
                @test ArrayInterface.ldlt_instance(SymTridiagonal(A' * A)) isa typeof(ldlt(SymTridiagonal(A' * A)))
            end
        end
    end

    for A in [sparse([1.0 2.0; 3.0 4.0])]
        @test ArrayInterface.lu_instance(A) isa typeof(lu(A))
        @test ArrayInterface.qr_instance(A) isa typeof(qr(A))
        if VERSION >= v"1.9-"
            @test ArrayInterface.cholesky_instance(A' * A) isa typeof(cholesky(A' * A))
        end
        @test ArrayInterface.ldlt_instance(SymTridiagonal(A' * A)) isa typeof(ldlt(SymTridiagonal(A' * A)))
    end
end

@testset "Array conversion" begin
    cv = ComponentVector((x = rand(3), y = rand(3)))
    @test ArrayInterface.has_trivial_array_constructor(typeof(cv), rand(6))
end

module ArrayInterfaceTrackerExt

using ArrayInterface
import Tracker

ArrayInterface.ismutable(::Type{<:Tracker.TrackedArray}) = false
ArrayInterface.ismutable(T::Type{<:Tracker.TrackedReal}) = false
ArrayInterface.can_setindex(::Type{<:Tracker.TrackedArray}) = false
ArrayInterface.fast_scalar_indexing(::Type{<:Tracker.TrackedArray}) = false
ArrayInterface.aos_to_soa(x::AbstractArray{<:Tracker.TrackedReal,N}) where {N} = Tracker.collect(x)

function ArrayInterface.restructure(x::Array, y::Tracker.TrackedArray)
    reshape(y, Base.size(x)...)
end
function ArrayInterface.restructure(x::Array, y::Array{<:Tracker.TrackedReal})
    reshape(y, Base.size(x)...)
end

end # module

module ArrayInterfaceFillArraysExt

using ArrayInterface: ArrayInterface
using FillArrays: AbstractFill, OneElement

ArrayInterface.can_setindex(::Type{<:AbstractFill}) = false
ArrayInterface.can_setindex(::Type{<:OneElement}) = false

end

module ArrayInterfaceBlockBandedMatricesExt

using ArrayInterface
using ArrayInterface: BandedMatrixIndex
using BlockBandedMatrices
using BlockBandedMatrices.BlockArrays

struct BlockBandedMatrixIndex <: ArrayInterface.MatrixIndex
    count::Int
    refinds::Array{Int,1}
    refcoords::Array{Int,1}# storing col or row inds at ref points
    isrow::Bool
end
Base.firstindex(i::BlockBandedMatrixIndex) = 1
Base.lastindex(i::BlockBandedMatrixIndex) = i.count
Base.length(i::BlockBandedMatrixIndex) = lastindex(i)
function BlockBandedMatrixIndex(nrowblock, ncolblock, rowsizes, colsizes, l, u)
    blockrowind = BandedMatrixIndex(nrowblock, ncolblock, l, u, true)
    blockcolind = BandedMatrixIndex(nrowblock, ncolblock, l, u, false)
    sortedinds = sort(
        [(blockrowind[i], blockcolind[i]) for i = 1:length(blockrowind)],
        by=x -> x[1],
    )
    sort!(sortedinds, by=x -> x[2], alg=InsertionSort)# stable sort keeps the second index in order
    refinds = Array{Int,1}()
    refrowcoords = Array{Int,1}()
    refcolcoords = Array{Int,1}()
    rowheights = pushfirst!(copy(rowsizes), 1)
    cumsum!(rowheights, rowheights)
    blockheight = 0
    blockrow = 1
    blockcol = 1
    currenti = 1
    lastrowind = sortedinds[1][1] - 1
    lastcolind = sortedinds[1][2]
    for ind in sortedinds
        rowind, colind = ind
        if colind == lastcolind
            if rowind > lastrowind
                blockheight += rowsizes[rowind]
            end
        else
            for j = blockcol:blockcol+colsizes[lastcolind]-1
                push!(refinds, currenti)
                push!(refrowcoords, blockrow)
                push!(refcolcoords, j)
                currenti += blockheight
            end
            blockcol += colsizes[lastcolind]
            blockrow = rowheights[rowind]
            blockheight = rowsizes[rowind]
        end
        lastcolind = colind
        lastrowind = rowind
    end
    for j = blockcol:blockcol+colsizes[lastcolind]-1
        push!(refinds, currenti)
        push!(refrowcoords, blockrow)
        push!(refcolcoords, j)
        currenti += blockheight
    end
    push!(refinds, currenti)# guard
    push!(refrowcoords, -1)
    push!(refcolcoords, -1)
    rowindobj = BlockBandedMatrixIndex(currenti - 1, refinds, refrowcoords, true)
    colindobj = BlockBandedMatrixIndex(currenti - 1, refinds, refcolcoords, false)
    rowindobj, colindobj
end
Base.@propagate_inbounds function Base.getindex(ind::BlockBandedMatrixIndex, i::Int)
    @boundscheck 1 <= i <= ind.count || throw(BoundsError(ind, i))
    p = 1
    while i - ind.refinds[p] >= 0
        p += 1
    end
    p -= 1
    _i = i - ind.refinds[p]
    if ind.isrow
        return ind.refcoords[p] + _i
    else
        return ind.refcoords[p]
    end
end

function ArrayInterface.findstructralnz(x::BlockBandedMatrices.BlockBandedMatrix)
    l, u = BlockBandedMatrices.blockbandwidths(x)
    nrowblock = BlockBandedMatrices.blocksize(x, 1)
    ncolblock = BlockBandedMatrices.blocksize(x, 2)
    rowsizes = BlockArrays.blocklengths(axes(x, 1))
    colsizes = BlockArrays.blocklengths(axes(x, 2))
    return BlockBandedMatrixIndex(
        nrowblock,
        ncolblock,
        rowsizes,
        colsizes,
        l,
        u,
    )
end
struct BandedBlockBandedMatrixIndex <: ArrayInterface.MatrixIndex
    count::Int
    refinds::Array{Int,1}
    refcoords::Array{Int,1}# storing col or row inds at ref points
    reflocalinds::Array{BandedMatrixIndex,1}
    isrow::Bool
end
Base.firstindex(i::BandedBlockBandedMatrixIndex) = 1
Base.lastindex(i::BandedBlockBandedMatrixIndex) = i.count
Base.length(i::BandedBlockBandedMatrixIndex) = lastindex(i)
Base.@propagate_inbounds function Base.getindex(ind::BandedBlockBandedMatrixIndex, i::Int)
    @boundscheck 1 <= i <= ind.count || throw(BoundsError(ind, i))
    p = 1
    while i - ind.refinds[p] >= 0
        p += 1
    end
    p -= 1
    _i = i - ind.refinds[p] + 1
    ind.reflocalinds[p][_i] + ind.refcoords[p] - 1
end


function BandedBlockBandedMatrixIndex(
    nrowblock,
    ncolblock,
    rowsizes,
    colsizes,
    l,
    u,
    lambda,
    mu,
)
    blockrowind = BandedMatrixIndex(nrowblock, ncolblock, l, u, true)
    blockcolind = BandedMatrixIndex(nrowblock, ncolblock, l, u, false)
    sortedinds = sort(
        [(blockrowind[i], blockcolind[i]) for i = 1:length(blockrowind)],
        by=x -> x[1],
    )
    sort!(sortedinds, by=x -> x[2], alg=InsertionSort)# stable sort keeps the second index in order
    rowheights = pushfirst!(copy(rowsizes), 1)
    cumsum!(rowheights, rowheights)
    colwidths = pushfirst!(copy(colsizes), 1)
    cumsum!(colwidths, colwidths)
    currenti = 1
    refinds = Array{Int,1}()
    refrowcoords = Array{Int,1}()
    refcolcoords = Array{Int,1}()
    reflocalrowinds = Array{BandedMatrixIndex,1}()
    reflocalcolinds = Array{BandedMatrixIndex,1}()
    for ind in sortedinds
        rowind, colind = ind
        localrowind =
            BandedMatrixIndex(rowsizes[rowind], colsizes[colind], lambda, mu, true)
        localcolind =
            BandedMatrixIndex(rowsizes[rowind], colsizes[colind], lambda, mu, false)
        push!(refinds, currenti)
        push!(refrowcoords, rowheights[rowind])
        push!(refcolcoords, colwidths[colind])
        push!(reflocalrowinds, localrowind)
        push!(reflocalcolinds, localcolind)
        currenti += localrowind.count
    end
    push!(refinds, currenti)
    push!(refrowcoords, -1)
    push!(refcolcoords, -1)
    rowindobj = BandedBlockBandedMatrixIndex(
        currenti - 1,
        refinds,
        refrowcoords,
        reflocalrowinds,
        true,
    )
    colindobj = BandedBlockBandedMatrixIndex(
        currenti - 1,
        refinds,
        refcolcoords,
        reflocalcolinds,
        false,
    )
    rowindobj, colindobj
end

function ArrayInterface.findstructralnz(x::BlockBandedMatrices.BandedBlockBandedMatrix)
    l, u = BlockBandedMatrices.blockbandwidths(x)
    lambda, mu = BlockBandedMatrices.subblockbandwidths(x)
    nrowblock = BlockBandedMatrices.blocksize(x, 1)
    ncolblock = BlockBandedMatrices.blocksize(x, 2)
    rowsizes = BlockArrays.blocklengths(axes(x, 1))
    colsizes = BlockArrays.blocklengths(axes(x, 2))
    return BandedBlockBandedMatrixIndex(
        nrowblock,
        ncolblock,
        rowsizes,
        colsizes,
        l,
        u,
        lambda,
        mu,
    )
end

ArrayInterface.has_sparsestruct(::Type{<:BlockBandedMatrices.BlockBandedMatrix}) = true
ArrayInterface.has_sparsestruct(::Type{<:BlockBandedMatrices.BandedBlockBandedMatrix}) = true
ArrayInterface.isstructured(::Type{<:BlockBandedMatrices.BlockBandedMatrix}) = true
ArrayInterface.isstructured(::Type{<:BlockBandedMatrices.BandedBlockBandedMatrix}) = true
ArrayInterface.fast_matrix_colors(::Type{<:BlockBandedMatrices.BlockBandedMatrix}) = true
ArrayInterface.fast_matrix_colors(::Type{<:BlockBandedMatrices.BandedBlockBandedMatrix}) = true

function ArrayInterface.matrix_colors(A::BlockBandedMatrices.BlockBandedMatrix)
    l, u = BlockBandedMatrices.blockbandwidths(A)
    blockwidth = l + u + 1
    nblock = BlockBandedMatrices.blocksize(A, 2)
    cols = BlockArrays.blocklengths(axes(A, 2))
    blockcolors = ArrayInterface._cycle(1:blockwidth, nblock)
    # the reserved number of colors of a block is the maximum length of columns of blocks with the same block color
    ncolors = [maximum(cols[i:blockwidth:nblock]) for i = 1:blockwidth]
    endinds = cumsum(ncolors)
    startinds = [endinds[i] - ncolors[i] + 1 for i = 1:blockwidth]
    colors = [
        (startinds[blockcolors[i]]:endinds[blockcolors[i]])[1:cols[i]]
        for i = 1:nblock
    ]
    return reduce(vcat, colors)
end

function ArrayInterface.matrix_colors(A::BlockBandedMatrices.BandedBlockBandedMatrix)
    l, u = BlockBandedMatrices.blockbandwidths(A)
    lambda, mu = BlockBandedMatrices.subblockbandwidths(A)
    blockwidth = l + u + 1
    subblockwidth = lambda + mu + 1
    nblock = BlockBandedMatrices.blocksize(A, 2)
    cols = BlockArrays.blocklengths(axes(A, 2))
    blockcolors = ArrayInterface._cycle(1:blockwidth, nblock)
    # the reserved number of colors of a block is the min of subblockwidth and the largest length of columns of blocks with the same block color
    ncolors = [
        min(subblockwidth, maximum(cols[i:blockwidth:nblock]))
        for i = 1:min(blockwidth, nblock)
    ]
    endinds = cumsum(ncolors)
    startinds = [endinds[i] - ncolors[i] + 1 for i = 1:min(blockwidth, nblock)]
    colors = [
        ArrayInterface._cycle(startinds[blockcolors[i]]:endinds[blockcolors[i]], cols[i])
        for i = 1:nblock
    ]
    return reduce(vcat, colors)
end

end # module

module ArrayInterface

using LinearAlgebra

@static if isdefined(Base, Symbol("@assume_effects"))
    using Base: @assume_effects
else
    macro assume_effects(args...)
        n = nfields(args)
        call = getfield(args, n)
        if n === 2 && getfield(args, 1) === QuoteNode(:total)
            return esc(:(Base.@pure $(call)))
        else
            return esc(call)
        end
    end
end
@assume_effects :total __parameterless_type(T)=Base.typename(T).wrapper
parameterless_type(x) = parameterless_type(typeof(x))
parameterless_type(x::Type) = __parameterless_type(x)

const VecAdjTrans{T, V <: AbstractVector{T}} = Union{Transpose{<:Any, V}, Adjoint{<:Any, V}}
const MatAdjTrans{T, M <: AbstractMatrix{T}} = Union{Transpose{<:Any, M}, Adjoint{<:Any, M}}
const UpTri{T, M} = Union{UpperTriangular{T, M}, UnitUpperTriangular{T, M}}
const LoTri{T, M} = Union{LowerTriangular{T, M}, UnitLowerTriangular{T, M}}

"""
    ArrayInterface.map_tuple_type(f, T::Type{<:Tuple})

Returns tuple where each field corresponds to the field type of `T` modified by the function `f`.

# Examples

```julia
julia> ArrayInterface.map_tuple_type(sqrt, Tuple{1,4,16})
(1.0, 2.0, 4.0)

```
"""
function map_tuple_type end
@inline function map_tuple_type(f, @nospecialize(T::Type))
    ntuple(i -> f(fieldtype(T, i)), Val{fieldcount(T)}())
end

"""
    ArrayInterface.flatten_tuples(t::Tuple) -> Tuple

Flattens any field of `t` that is a tuple. Only direct fields of `t` may be flattened.

# Examples

```julia
julia> ArrayInterface.flatten_tuples((1, ()))
(1,)

julia> ArrayInterface.flatten_tuples((1, (2, 3)))
(1, 2, 3)

julia> ArrayInterface.flatten_tuples((1, (2, (3,))))
(1, 2, (3,))

```
"""
function flatten_tuples end
function flatten_tuples(t::Tuple)
    fields = _new_field_positions(t)
    ntuple(Val{nfields(fields)}()) do k
        i, j = getfield(fields, k)
        i = length(t) - i
        @inbounds j === 0 ? getfield(t, i) : getfield(getfield(t, i), j)
    end
end
_new_field_positions(::Tuple{}) = ()
@nospecialize
function _new_field_positions(x::Tuple)
    (_fl1(x, x[1])..., _new_field_positions(Base.tail(x))...)
end
_fl1(x::Tuple, x1::Tuple) = ntuple(Base.Fix1(tuple, length(x) - 1), Val(length(x1)))
_fl1(x::Tuple, x1) = ((length(x) - 1, 0),)
@specialize

"""
    parent_type(::Type{T}) -> Type

Returns the parent array that type `T` wraps.
"""
parent_type(x) = parent_type(typeof(x))
parent_type(@nospecialize T::Type{<:Union{Symmetric, Hermitian}}) = fieldtype(T, :data)
parent_type(@nospecialize T::Type{<:Union{UpTri, LoTri}}) = fieldtype(T, :data)
parent_type(@nospecialize T::Type{<:PermutedDimsArray}) = fieldtype(T, :parent)
parent_type(@nospecialize T::Type{<:Adjoint}) = fieldtype(T, :parent)
parent_type(@nospecialize T::Type{<:Transpose}) = fieldtype(T, :parent)
parent_type(@nospecialize T::Type{<:SubArray}) = fieldtype(T, :parent)
parent_type(@nospecialize T::Type{<:Base.ReinterpretArray}) = fieldtype(T, :parent)
parent_type(@nospecialize T::Type{<:Base.ReshapedArray}) = fieldtype(T, :parent)
function parent_type(@nospecialize T::Type{<:Union{Base.Slice, Base.IdentityUnitRange}})
    fieldtype(T, :indices)
end
parent_type(@nospecialize T::Type{<:Diagonal}) = fieldtype(T, :diag)
parent_type(T::Type) = T

"""
    promote_eltype(::Type{<:AbstractArray{T,N}}, ::Type{T2})

Computes the type of the `AbstractArray` that results from the element
type changing to `promote_type(T,T2)`.

Note that no generic fallback is given.
"""
function promote_eltype end
function promote_eltype(::Type{Array{T, N}}, ::Type{T2}) where {T, T2, N}
    Array{promote_type(T, T2), N}
end

"""
    buffer(x)

Return the buffer data that `x` points to. Unlike `parent(x::AbstractArray)`, `buffer(x)`
may not return another array type.
"""
buffer(x) = parent(x)
buffer(@nospecialize x::Union{Base.Slice, Base.IdentityUnitRange}) = getfield(x, :indices)

"""
    is_forwarding_wrapper(::Type{T}) -> Bool

Returns `true` if the type `T` wraps another data type and does not alter any of its
standard interface. For example, if `T` were an array then its size, indices, and elements
would all be equivalent to its wrapped data.
"""
is_forwarding_wrapper(T::Type) = false
is_forwarding_wrapper(@nospecialize T::Type{<:Base.Slice}) = true
is_forwarding_wrapper(@nospecialize x) = is_forwarding_wrapper(typeof(x))

"""
    GetIndex(buffer) = GetIndex{true}(buffer)
    GetIndex{check}(buffer) -> g

Wraps an indexable buffer in a function type that is indexed when called, so that `g(inds..)`
is equivalent to `buffer[inds...]`. If `check` is `false`, then all indexing arguments are
considered in-bounds. The default value for `check` is `true`, requiring bounds checking for
each index.

See also [`SetIndex!`](@ref)

!!! warning
    Passing `false` as `check` may result in incorrect results/crashes/corruption for
    out-of-bounds indices, similar to inappropriate use of `@inbounds`. The user is
    responsible for ensuring this is correctly used.

# Examples

```julia
julia> ArrayInterface.GetIndex(1:10)(3)
3

julia> ArrayInterface.GetIndex{false}(1:10)(11)  # shouldn't be in-bounds
11

```

"""
struct GetIndex{CB, B} <: Function
    buffer::B

    GetIndex{true, B}(b) where {B} = new{true, B}(b)
    GetIndex{false, B}(b) where {B} = new{false, B}(b)
    GetIndex{check}(b::B) where {check, B} = GetIndex{check, B}(b)
    GetIndex(b) = GetIndex{true}(b)
end

"""
    SetIndex!(buffer) = SetIndex!{true}(buffer)
    SetIndex!{check}(buffer) -> g

Wraps an indexable buffer in a function type that sets a value at an index when called, so
that `g(val, inds..)` is equivalent to `setindex!(buffer, val, inds...)`. If `check` is
`false`, then all indexing arguments are considered in-bounds. The default value for `check`
is `true`, requiring bounds checking for each index.

See also [`GetIndex`](@ref)

!!! warning
    Passing `false` as `check` may result in incorrect results/crashes/corruption for
    out-of-bounds indices, similar to inappropriate use of `@inbounds`. The user is
    responsible for ensuring this is correctly used.

# Examples

```julia

julia> x = [1, 2, 3, 4];

julia> ArrayInterface.SetIndex!(x)(10, 2);

julia> x[2]
10

```
"""
struct SetIndex!{CB, B} <: Function
    buffer::B

    SetIndex!{true, B}(b) where {B} = new{true, B}(b)
    SetIndex!{false, B}(b) where {B} = new{false, B}(b)
    SetIndex!{check}(b::B) where {check, B} = SetIndex!{check, B}(b)
    SetIndex!(b) = SetIndex!{true}(b)
end

buffer(x::Union{SetIndex!, GetIndex}) = getfield(x, :buffer)

Base.@propagate_inbounds @inline (g::GetIndex{true})(inds...) = buffer(g)[inds...]
@inline (g::GetIndex{false})(inds...) = @inbounds(buffer(g)[inds...])
Base.@propagate_inbounds @inline function (s::SetIndex!{true})(v, inds...)
    setindex!(buffer(s), v, inds...)
end
@inline (s::SetIndex!{false})(v, inds...) = @inbounds(setindex!(buffer(s), v, inds...))

"""
    can_change_size(::Type{T}) -> Bool

Returns `true` if the Base.size of `T` can change, in which case operations
such as `pop!` and `popfirst!` are available for collections of type `T`.
"""
can_change_size(x) = can_change_size(typeof(x))
function can_change_size(::Type{T}) where {T}
    is_forwarding_wrapper(T) ? can_change_size(parent_type(T)) : false
end
can_change_size(::Type{<:Vector}) = true
can_change_size(::Type{<:AbstractDict}) = true
can_change_size(::Type{<:Base.ImmutableDict}) = false

function ismutable end

"""
    ismutable(::Type{T}) -> Bool

Query whether instances of type `T` are mutable or not, see
https://github.com/JuliaDiffEq/RecursiveArrayTools.jl/issues/19.
"""
ismutable(x) = ismutable(typeof(x))
function ismutable(::Type{T}) where {T <: AbstractArray}
    if parent_type(T) <: T
        return true
    else
        return ismutable(parent_type(T))
    end
end
ismutable(::Type{<:AbstractRange}) = false
ismutable(::Type{<:AbstractDict}) = true
ismutable(::Type{<:Base.ImmutableDict}) = false
ismutable(::Type{BigFloat}) = false
ismutable(::Type{BigInt}) = false
function ismutable(::Type{T}) where {T}
    if parent_type(T) <: T
        return Base.ismutabletype(T)
    else
        return ismutable(parent_type(T))
    end
end

"""
    can_setindex(::Type{T}) -> Bool

Query whether a type can use `setindex!`.
"""
can_setindex(x) = can_setindex(typeof(x))
can_setindex(T::Type) = is_forwarding_wrapper(T) ? can_setindex(parent_type(T)) : true
can_setindex(@nospecialize T::Type{<:AbstractRange}) = false
can_setindex(::Type{<:AbstractDict}) = true
can_setindex(::Type{<:Base.ImmutableDict}) = false
can_setindex(@nospecialize T::Type{<:Tuple}) = false
can_setindex(@nospecialize T::Type{<:NamedTuple}) = false
can_setindex(::Type{<:Base.Iterators.Pairs{<:Any, <:Any, P}}) where {P} = can_setindex(P)

"""
    aos_to_soa(x)

Converts an array of structs formulation to a struct of array.
"""
aos_to_soa(x) = x

"""
    isstructured(::Type{T}) -> Bool

Query whether a type is a representation of a structured matrix.
"""
isstructured(x) = isstructured(typeof(x))
isstructured(::Type) = false
isstructured(::Type{<:Symmetric}) = true
isstructured(::Type{<:Hermitian}) = true
isstructured(::Type{<:UpperTriangular}) = true
isstructured(::Type{<:LowerTriangular}) = true
isstructured(::Type{<:Tridiagonal}) = true
isstructured(::Type{<:SymTridiagonal}) = true
isstructured(::Type{<:Bidiagonal}) = true
isstructured(::Type{<:Diagonal}) = true

"""
    has_sparsestruct(x::AbstractArray) -> Bool

Determine whether `findstructralnz` accepts the parameter `x`.
"""
has_sparsestruct(x) = has_sparsestruct(typeof(x))
has_sparsestruct(::Type) = false
has_sparsestruct(::Type{<:AbstractArray}) = false
has_sparsestruct(::Type{<:Diagonal}) = true
has_sparsestruct(::Type{<:Bidiagonal}) = true
has_sparsestruct(::Type{<:Tridiagonal}) = true
has_sparsestruct(::Type{<:SymTridiagonal}) = true

"""
    issingular(A::AbstractMatrix) -> Bool

Determine whether a given abstract matrix is singular.
"""
issingular(A::AbstractMatrix) = issingular(Matrix(A))
issingular(A::Matrix) = !issuccess(lu(A, check = false))
issingular(A::UniformScaling) = A.λ == 0
issingular(A::Diagonal) = any(iszero, A.diag)
issingular(A::Bidiagonal) = any(iszero, A.dv)
issingular(A::SymTridiagonal) = diaganyzero(ldlt(A).data)
issingular(A::Tridiagonal) = !issuccess(lu(A, check = false))
issingular(A::Union{Hermitian, Symmetric}) = diaganyzero(bunchkaufman(A, check = false).LD)
issingular(A::Union{LowerTriangular, UpperTriangular}) = diaganyzero(A.data)
issingular(A::Union{UnitLowerTriangular, UnitUpperTriangular}) = false
issingular(A::Union{Adjoint, Transpose}) = issingular(parent(A))
diaganyzero(A) = any(iszero, view(A, diagind(A)))

"""
    findstructralnz(x::AbstractArray)

Return: (I,J) #indexable objects
Find sparsity pattern of special matrices, the same as the first two elements of findnz(::SparseMatrixCSC).
"""
function findstructralnz(x::Diagonal)
    n = Base.size(x, 1)
    (1:n, 1:n)
end

function findstructralnz(x::Bidiagonal)
    n = Base.size(x, 1)
    isup = x.uplo == 'U' ? true : false
    rowind = BidiagonalIndex(n + n - 1, isup)
    colind = BidiagonalIndex(n + n - 1, !isup)
    (rowind, colind)
end

function findstructralnz(x::Union{Tridiagonal, SymTridiagonal})
    n = Base.size(x, 1)
    rowind = TridiagonalIndex(n + n - 1 + n - 1, n, true)
    colind = TridiagonalIndex(n + n - 1 + n - 1, n, false)
    (rowind, colind)
end

abstract type ColoringAlgorithm end

"""
    fast_matrix_colors(A)

Query whether a matrix has a fast algorithm for getting the structural
colors of the matrix.
"""
fast_matrix_colors(A) = false
fast_matrix_colors(A::AbstractArray) = fast_matrix_colors(typeof(A))
function fast_matrix_colors(A::Type{
                                    <:Union{Diagonal, Bidiagonal, Tridiagonal,
                                            SymTridiagonal}})
    true
end

"""
    matrix_colors(A::Union{Array,UpperTriangular,LowerTriangular})

The color vector for dense matrix and triangular matrix is simply
`[1,2,3,..., Base.size(A,2)]`.
"""
function matrix_colors(A::Union{Array, UpperTriangular, LowerTriangular})
    eachindex(1:Base.size(A, 2)) # Vector Base.size matches number of rows
end
matrix_colors(A::Diagonal) = fill(1, Base.size(A, 2))
matrix_colors(A::Bidiagonal) = _cycle(1:2, Base.size(A, 2))
matrix_colors(A::Union{Tridiagonal, SymTridiagonal}) = _cycle(1:3, Base.size(A, 2))
_cycle(repetend, len) = repeat(repetend, div(len, length(repetend)) + 1)[1:len]

"""
bunchkaufman_instance(A, pivot = LinearAlgebra.RowMaximum()) -> bunchkaufman_factorization_instance

Returns an instance of the Bunch-Kaufman factorization object with the correct type
cheaply.
"""
function bunchkaufman_instance(A::Matrix{T}) where T
    return bunchkaufman(similar(A, 0, 0), check = false)
end

"""
bunchkaufman_instance(a::Number) -> a

Returns the number.
"""
bunchkaufman_instance(a::Number) = a

"""
bunchkaufman_instance(a::Any) -> cholesky(a, check=false)

Returns the number.
"""
bunchkaufman_instance(a::Any) = bunchkaufman(a, check = false)

const DEFAULT_CHOLESKY_PIVOT = LinearAlgebra.NoPivot()

"""
cholesky_instance(A, pivot = LinearAlgebra.RowMaximum()) -> cholesky_factorization_instance

Returns an instance of the Cholesky factorization object with the correct type
cheaply.
"""
function cholesky_instance(A::Matrix{T}, pivot = DEFAULT_CHOLESKY_PIVOT) where {T}
    return cholesky(similar(A, 0, 0), pivot, check = false)
end

"""
cholesky_instance(a::Number, pivot = LinearAlgebra.RowMaximum()) -> a

Returns the number.
"""
cholesky_instance(a::Number, pivot = DEFAULT_CHOLESKY_PIVOT) = a

"""
cholesky_instance(a::Any, pivot = LinearAlgebra.RowMaximum()) -> cholesky(a, check=false)

Slow fallback which gets the instance via factorization. Should get
specialized for new matrix types.
"""
cholesky_instance(a::Any, pivot = DEFAULT_CHOLESKY_PIVOT) = cholesky(a, pivot, check = false)

"""
ldlt_instance(A) -> ldlt_factorization_instance

Returns an instance of the LDLT factorization object with the correct type
cheaply.
"""
function ldlt_instance(A::Matrix{T}) where {T}
    return ldlt_instance(SymTridiagonal(similar(A, 0, 0)))
end

function ldlt_instance(A::SymTridiagonal{T,V}) where {T,V}
    return LinearAlgebra.LDLt{T,SymTridiagonal{T,V}}(A)
end

"""
ldlt_instance(a::Number) -> a

Returns the number.
"""
ldlt_instance(a::Number) = a

"""
ldlt_instance(a::Any) -> ldlt(a, check=false)

Slow fallback which gets the instance via factorization. Should get
specialized for new matrix types.
"""
ldlt_instance(a::Any) = ldlt(a)

"""
  lu_instance(A) -> lu_factorization_instance

Returns an instance of the LU factorization object with the correct type
cheaply.
"""
function lu_instance(A::Matrix{T}) where {T}
    noUnitT = typeof(zero(T))
    luT = LinearAlgebra.lutype(noUnitT)
    ipiv = Vector{LinearAlgebra.BlasInt}(undef, 0)
    info = zero(LinearAlgebra.BlasInt)
    return LU{luT}(similar(A, 0, 0), ipiv, info)
end

function lu_instance(A::Symmetric{T}) where {T}
    noUnitT = typeof(zero(T))
    luT = LinearAlgebra.lutype(noUnitT)
    ipiv = Vector{LinearAlgebra.BlasInt}(undef, 0)
    info = zero(LinearAlgebra.BlasInt)
    return LU{luT}(similar(A, 0, 0), ipiv, info)
end

noalloc_diag(A::Diagonal) = A.diag
noalloc_diag(A::Tridiagonal) = A.d
noalloc_diag(A::SymTridiagonal) = A.dv

function lu_instance(A::Union{Tridiagonal{T},Diagonal{T},SymTridiagonal{T}}) where {T}
    noUnitT = typeof(zero(T))
    luT = LinearAlgebra.lutype(noUnitT)
    ipiv = Vector{LinearAlgebra.BlasInt}(undef, 0)
    info = zero(LinearAlgebra.BlasInt)
    vectype = similar(noalloc_diag(A), 0)
    newA = Tridiagonal(vectype, vectype, vectype)
    return LU{luT}(newA, ipiv, info)
end

"""
  lu_instance(a::Number) -> a

Returns the number.
"""
lu_instance(a::Number) = a

"""
    lu_instance(a::Any) -> lu(a, check=false)

Slow fallback which gets the instance via factorization. Should get
specialized for new matrix types.
"""
lu_instance(a::Any) = lu(a, check = false)

"""
  qr_instance(A, pivot = NoPivot()) -> qr_factorization_instance

Returns an instance of the QR factorization object with the correct type
cheaply.
"""
function qr_instance(A::Matrix{T},pivot = DEFAULT_CHOLESKY_PIVOT) where {T}
    if pivot === DEFAULT_CHOLESKY_PIVOT
        LinearAlgebra.QRCompactWY(zeros(T,0,0),zeros(T,0,0))
    else
        LinearAlgebra.QRPivoted(zeros(T,0,0),zeros(T,0),zeros(Int,0))
    end
end

function qr_instance(A::Matrix{BigFloat},pivot = DEFAULT_CHOLESKY_PIVOT)
    LinearAlgebra.QR(zeros(BigFloat,0,0),zeros(BigFloat,0))
end

"""
  qr_instance(a::Number) -> a

Returns the number.
"""
qr_instance(a::Number, pivot = DEFAULT_CHOLESKY_PIVOT) = a

"""
    qr_instance(a::Any) -> qr(a)

Slow fallback which gets the instance via factorization. Should get
specialized for new matrix types.
"""
qr_instance(a::Any, pivot = DEFAULT_CHOLESKY_PIVOT) = qr(a)# check = false)

"""
  svd_instance(A) -> qr_factorization_instance

Returns an instance of the SVD factorization object with the correct type
cheaply.
"""
function svd_instance(A::Matrix{T}) where {T}
    LinearAlgebra.SVD(zeros(T,0,0),zeros(real(T),0),zeros(T,0,0))
end

"""
  svd_instance(a::Number) -> a

Returns the number.
"""
svd_instance(a::Number) = a

"""
    svd_instance(a::Any) -> svd(a)

Slow fallback which gets the instance via factorization. Should get
specialized for new matrix types.
"""
svd_instance(a::Any) = svd(a) #check = false)

"""
    safevec(v)

It is a form of `vec` which is safe for all values in vector spaces, i.e., if it
is already a vector, like an AbstractVector or Number, it will return said
AbstractVector or Number.
"""
safevec(v) = vec(v)
safevec(v::Number) = v
safevec(v::AbstractVector) = v

"""
    zeromatrix(u::AbstractVector)

Creates the zero'd matrix version of `u`. Note that this is unique because
`similar(u,length(u),length(u))` returns a mutable type, so it is not type-matching,
while `fill(zero(eltype(u)),length(u),length(u))` doesn't match the array type,
i.e., you'll get a CPU array from a GPU array. The generic fallback is
`u .* u' .* false`, which works on a surprising number of types, but can be broken
with weird (recursive) broadcast overloads. For higher-order tensors, this
returns the matrix linear operator type which acts on the `vec` of the array.
"""
function zeromatrix(u)
    x = safevec(u)
    x .* x' .* false
end

# Reduces compile time burdens
function zeromatrix(u::Array{T}) where {T}
    out = Matrix{T}(undef, length(u), length(u))
    fill!(out, false)
end

"""
    undefmatrix(u::AbstractVector)

Creates the matrix version of `u` with possibly undefined values. Note that this is unique because
`similar(u,length(u),length(u))` returns a mutable type, so it is not type-matching,
while `fill(zero(eltype(u)),length(u),length(u))` doesn't match the array type,
i.e., you'll get a CPU array from a GPU array. The generic fallback is
`u .* u'`, which works on a surprising number of types, but can be broken
with weird (recursive) broadcast overloads. For higher-order tensors, this
returns the matrix linear operator type which acts on the `vec` of the array.
"""
function undefmatrix(u)
    similar(u, length(u), length(u))
end
function undefmatrix(u::Number)
    return zero(u)
end
"""
    restructure(x,y)

Restructures the object `y` into a shape of `x`, keeping its values intact. For
simple objects like an `Array`, this simply amounts to a reshape. However, for
more complex objects such as an `ArrayPartition`, not all of the structural
information is adequately contained in the type for standard tools to work. In
these cases, `restructure` gives a way to convert for example an `Array` into
a matching `ArrayPartition`.
"""
function restructure(x, y)
    out = similar(x, eltype(y))
    vec(out) .= vec(y)
    out
end

function restructure(x::Array, y)
    reshape(convert(Array, y), Base.size(x)...)
end

abstract type AbstractDevice end
abstract type AbstractCPU <: AbstractDevice end
struct CPUPointer <: AbstractCPU end
struct CPUTuple <: AbstractCPU end
struct CheckParent end
struct CPUIndex <: AbstractCPU end
struct GPU <: AbstractDevice end

"""
    device(::Type{T}) -> AbstractDevice

Indicates the most efficient way to access elements from the collection in low-level code.
For `GPUArrays`, will return `ArrayInterface.GPU()`.
For `AbstractArray` supporting a `pointer` method, returns `ArrayInterface.CPUPointer()`.
For other `AbstractArray`s and `Tuple`s, returns `ArrayInterface.CPUIndex()`.
Otherwise, returns `nothing`.
"""
device(A) = device(typeof(A))
device(::Type) = nothing
device(::Type{<:Tuple}) = CPUTuple()
device(::Type{T}) where {T <: Array} = CPUPointer()
device(::Type{T}) where {T <: AbstractArray} = _device(parent_type(T), T)
function _device(::Type{P}, ::Type{T}) where {P, T}
    if defines_strides(T)
        return device(P)
    else
        return _not_pointer(device(P))
    end
end
_not_pointer(::CPUPointer) = CPUIndex()
_not_pointer(x) = x
_device(::Type{T}, ::Type{T}) where {T <: DenseArray} = CPUPointer()
_device(::Type{T}, ::Type{T}) where {T} = CPUIndex()

"""
    can_avx(f) -> Bool

Returns `true` if the function `f` is guaranteed to be compatible with
`LoopVectorization.@avx` for supported element and array types. While a return
value of `false` does not indicate the function isn't supported, this allows a
library to conservatively apply `@avx` only when it is known to be safe to do so.

```julia
function mymap!(f, y, args...)
    if can_avx(f)
        @avx @. y = f(args...)
    else
        @. y = f(args...)
    end
end
```
"""
can_avx(::Any) = false

"""
    fast_scalar_indexing(::Type{T}) -> Bool

Query whether an array type has fast scalar indexing.
"""
fast_scalar_indexing(x) = fast_scalar_indexing(typeof(x))
fast_scalar_indexing(::Type) = true
fast_scalar_indexing(::Type{<:LinearAlgebra.AbstractQ}) = false
fast_scalar_indexing(::Type{<:LinearAlgebra.LQPackedQ}) = false

"""
    allowed_getindex(x,i...)

A scalar `getindex` which is always allowed.
"""
allowed_getindex(x, i...) = x[i...]

"""
    allowed_setindex!(x,v,i...)

A scalar `setindex!` which is always allowed.
"""
allowed_setindex!(x, v, i...) = Base.setindex!(x, v, i...)

"""
    ArrayIndex{N}

Subtypes of `ArrayIndex` represent series of transformations for a provided index to some
buffer which is typically accomplished with square brackets (e.g., `buffer[index[inds...]]`).
The only behavior that is required of a subtype of `ArrayIndex` is the ability to transform
individual index elements (i.e. not collections). This does not guarantee bounds checking or
the ability to iterate (although additional functionality may be provided for specific
types).
"""
abstract type ArrayIndex{N} end

const MatrixIndex = ArrayIndex{2}

const VectorIndex = ArrayIndex{1}

Base.ndims(::ArrayIndex{N}) where {N} = N
Base.ndims(::Type{<:ArrayIndex{N}}) where {N} = N

struct BidiagonalIndex <: MatrixIndex
    count::Int
    isup::Bool
end

struct TridiagonalIndex <: MatrixIndex
    count::Int# count==nsize+nsize-1+nsize-1
    nsize::Int
    isrow::Bool
end

Base.firstindex(i::Union{BidiagonalIndex, TridiagonalIndex}) = 1
Base.lastindex(i::Union{BidiagonalIndex, TridiagonalIndex}) = i.count
Base.length(i::Union{BidiagonalIndex, TridiagonalIndex}) = lastindex(i)

Base.@propagate_inbounds function Base.getindex(ind::BidiagonalIndex, i::Int)
    @boundscheck 1 <= i <= ind.count || throw(BoundsError(ind, i))
    if ind.isup
        ii = i + 1
    else
        ii = i + 1 + 1
    end
    convert(Int, floor(ii / 2))
end

Base.@propagate_inbounds function Base.getindex(ind::TridiagonalIndex, i::Int)
    @boundscheck 1 <= i <= ind.count || throw(BoundsError(ind, i))
    offsetu = ind.isrow ? 0 : 1
    offsetl = ind.isrow ? 1 : 0
    if 1 <= i <= ind.nsize
        return i
    elseif ind.nsize < i <= ind.nsize + ind.nsize - 1
        return i - ind.nsize + offsetu
    else
        return i - (ind.nsize + ind.nsize - 1) + offsetl
    end
end


"""
    ndims_index(::Type{I}) -> Int

Returns the number of dimensions that an instance of `I` indexes into. If this method is
not explicitly defined, then `1` is returned.

See also [`ndims_shape`](@ref)

# Examples

```julia
julia> ArrayInterface.ndims_index(Int)
1

julia> ArrayInterface.ndims_index(CartesianIndex(1, 2, 3))
3

julia> ArrayInterface.ndims_index([CartesianIndex(1, 2), CartesianIndex(1, 3)])
2

```
"""
ndims_index(::Type{<:Base.AbstractCartesianIndex{N}}) where {N} = N
# preserve CartesianIndices{0} as they consume a dimension.
ndims_index(::Type{CartesianIndices{0, Tuple{}}}) = 1
ndims_index(@nospecialize T::Type{<:AbstractArray{Bool}}) = ndims(T)
ndims_index(@nospecialize T::Type{<:AbstractArray}) = ndims_index(eltype(T))
ndims_index(@nospecialize T::Type{<:Base.LogicalIndex}) = ndims(fieldtype(T, :mask))
ndims_index(T::Type) = 1
ndims_index(@nospecialize(i)) = ndims_index(typeof(i))

"""
    ndims_shape(::Type{I}) -> Union{Int,Tuple{Vararg{Int}}}

Returns the number of dimension that are represented in the shape of the returned array when
indexing with an instance of `I`.

See also [`ndims_index`](@ref)

# Examples

```julia
julia> ArrayInterface.ndims_shape([CartesianIndex(1, 1), CartesianIndex(1, 2)])
1

julia> ndims(CartesianIndices((2,2))[[CartesianIndex(1, 1), CartesianIndex(1, 2)]])
1

"""
ndims_shape(T::DataType) = ndims_index(T)
ndims_shape(::Type{Colon}) = 1
ndims_shape(@nospecialize T::Type{<:CartesianIndices}) = ndims(T)
ndims_shape(@nospecialize T::Type{<:Union{Number, Base.AbstractCartesianIndex}}) = 0
ndims_shape(@nospecialize T::Type{<:AbstractArray{Bool}}) = 1
ndims_shape(@nospecialize T::Type{<:AbstractArray}) = ndims(T)
ndims_shape(x) = ndims_shape(typeof(x))



"""
    instances_do_not_alias(::Type{T}) -> Bool

Is it safe to `ivdep` arrays containing elements of type `T`?
That is, would it be safe to write to an array full of `T` in parallel?
This is not true for `mutable struct`s in general, where editing one index
could edit other indices.
That is, it is not safe when different instances may alias the same memory.
"""
instances_do_not_alias(::Type{T}) where {T} = Base.isbitstype(T)

"""
    indices_do_not_alias(::Type{T<:AbstractArray}) -> Bool

Is it safe to `ivdep` arrays of type `T`?
That is, would it be safe to write to an array of type `T` in parallel?
Examples where this is not true are `BitArray`s or `view(rand(6), [1,2,3,1,2,3])`.
That is, it is not safe whenever different indices may alias the same memory.
"""
indices_do_not_alias(::Type{T}) where {T} = _indices_do_not_alias(T)
function indices_do_not_alias(::Type{A}) where {T, A <: Base.StridedArray{T}}
    instances_do_not_alias(T)
end
function indices_do_not_alias(::Type{Adjoint{T, A}}) where {T, A <: AbstractArray{T}}
    indices_do_not_alias(A)
end
function indices_do_not_alias(::Type{Transpose{T, A}}) where {T, A <: AbstractArray{T}}
    indices_do_not_alias(A)
end
_indices_do_not_alias(::Type) = false
function _indices_do_not_alias(::Type{<:SubArray{<:Any, <:Any, A, I}}) where
    {
     A,
     I <: Tuple{
           Vararg{
                  Union{Integer, UnitRange, Base.ReshapedUnitRange,
                        Base.AbstractCartesianIndex}}}}
    indices_do_not_alias(A)
end

"""
    defines_strides(::Type{T}) -> Bool

Is strides(::T) defined? It is assumed that types returning `true` also return a valid
pointer on `pointer(::T)`.
"""
defines_strides(x) = defines_strides(typeof(x))
_defines_strides(::Type{T}, ::Type{T}) where {T} = false
_defines_strides(::Type{P}, ::Type{T}) where {P, T} = defines_strides(P)
defines_strides(::Type{T}) where {T} = _defines_strides(parent_type(T), T)
defines_strides(@nospecialize T::Type{<:StridedArray}) = true
defines_strides(@nospecialize T::Type{<:BitArray}) = true
@inline function defines_strides(@nospecialize T::Type{<:SubArray})
    stride_preserving_index(fieldtype(T, :indices))
end

#=
    stride_preserving_index(::Type{T}) -> Bool

Returns `True` if strides between each element can still be derived when indexing with an
instance of type `T`.
=#
stride_preserving_index(@nospecialize T::Type{<:AbstractRange}) = true
stride_preserving_index(@nospecialize T::Type{<:Number}) = true
@inline function stride_preserving_index(@nospecialize T::Type{<:Tuple})
    all(map_tuple_type(stride_preserving_index, T))
end
stride_preserving_index(@nospecialize T::Type) = false

## Stubs
struct BandedMatrixIndex <: ArrayInterface.MatrixIndex
    count::Int
    rowsize::Int
    colsize::Int
    bandinds::Array{Int,1}
    bandsizes::Array{Int,1}
    isrow::Bool
end

"""
    ensures_all_unique(T::Type) -> Bool

Returns `true` if all instances of type `T` are composed of a unique set of elements.
This does not require that `T` subtypes `AbstractSet` or implements the `AbstractSet`
interface.

# Examples

```julia
julia> ArrayInterface.ensures_all_unique(BitSet())
true

julia> ArrayInterface.ensures_all_unique([])
false

julia> ArrayInterface.ensures_all_unique(typeof(1:10))
true

julia> ArrayInterface.ensures_all_unique(LinRange(1, 1, 10))
false
```
"""
ensures_all_unique(@nospecialize T::Type{<:Union{AbstractSet,AbstractDict}}) = true
ensures_all_unique(@nospecialize T::Type{<:LinRange}) = false
ensures_all_unique(@nospecialize T::Type{<:AbstractRange}) = true
@inline function ensures_all_unique(T::Type)
    is_forwarding_wrapper(T) ? ensures_all_unique(parent_type(T)) : false
end
ensures_all_unique(@nospecialize(x)) = ensures_all_unique(typeof(x))

"""
    ensures_sorted(T::Type) -> Bool

Returns `true` if all instances of `T` are sorted.

# Examples

```julia
julia> ArrayInterface.ensures_sorted(BitSet())
true

julia> ArrayInterface.ensures_sorted([])
false

julia> ArrayInterface.ensures_sorted(1:10)
true
```
"""
ensures_sorted(@nospecialize(T::Type{BitSet})) = true
ensures_sorted(@nospecialize( T::Type{<:AbstractRange})) = true
ensures_sorted(T::Type) = is_forwarding_wrapper(T) ? ensures_sorted(parent_type(T)) : false
ensures_sorted(@nospecialize(x)) = ensures_sorted(typeof(x))

"""
    has_trivial_array_constructor(T::Type, args...) -> Bool

Returns `true` if an object of type `T` can be constructed using the collection of `args`

Note: This checks if a compatible `convert` methood exists between `T` and `args`

# Examples:

```julia
julia> ca = ComponentVector((x = rand(3), y = rand(4),))
ComponentVector{Float64}(x = [0.6549137106381634, 0.37555505280294565, 0.8521039568665254], y = [0.40314196291239024, 0.35484725607638834, 0.6580528978034597, 0.10055508457632167])

julia> ArrayInterface.has_trivial_array_constructor(typeof(ca), ones(6))
true

julia> ArrayInterface.has_trivial_array_constructor(typeof(cv), (x = rand(6),))
false
```
"""
function has_trivial_array_constructor(::Type{T}, args...) where T
    applicable(convert, T, args...)
end

end # module

using AMDGPU
using ArrayInterface
using LinearAlgebra

using Test

A = ROCMatrix(Float32[1 0; 0 1])

# Test that lu_instance works with AMDGPU.jl ROC arrays
@test isa(ArrayInterface.lu_instance(A), LU)

# Test that device returns GPU()
@test ArrayInterface.device(typeof(A)) == ArrayInterface.GPU()

using ArrayInterface
using BandedMatrices
using Test

function checkequal(idx1::ArrayInterface.BandedMatrixIndex,
    idx2::ArrayInterface.BandedMatrixIndex)
    return idx1.rowsize == idx2.rowsize && idx1.colsize == idx2.colsize &&
           idx1.bandinds == idx2.bandinds && idx1.bandsizes == idx2.bandsizes &&
           idx1.isrow == idx2.isrow && idx1.count == idx2.count
end

B = BandedMatrix(Ones(5, 5), (-1, 2))
B[band(1)] .= [1, 2, 3, 4]
B[band(2)] .= [5, 6, 7]
@test ArrayInterface.has_sparsestruct(B)
rowind, colind = ArrayInterface.findstructralnz(B)
@test [B[rowind[i], colind[i]] for i in 1:length(rowind)] == [5, 6, 7, 1, 2, 3, 4]
B = BandedMatrix(Ones(4, 6), (-1, 2))
B[band(1)] .= [1, 2, 3, 4]
B[band(2)] .= [5, 6, 7, 8]
rowind, colind = ArrayInterface.findstructralnz(B)
@test [B[rowind[i], colind[i]] for i in 1:length(rowind)] == [5, 6, 7, 8, 1, 2, 3, 4]
@test ArrayInterface.isstructured(typeof(B))
@test ArrayInterface.fast_matrix_colors(typeof(B))

for op in (adjoint, transpose)
    B = BandedMatrix(Ones(5, 5), (-1, 2))
    B[band(1)] .= [1, 2, 3, 4]
    B[band(2)] .= [5, 6, 7]
    B′ = op(B)
    @test ArrayInterface.has_sparsestruct(B′)
    rowind′, colind′ = ArrayInterface.findstructralnz(B′)
    rowind′′, colind′′ = ArrayInterface.findstructralnz(BandedMatrix(B′))
    @test checkequal(rowind′, rowind′′)
    @test checkequal(colind′, colind′′)

    B = BandedMatrix(Ones(4, 6), (-1, 2))
    B[band(1)] .= [1, 2, 3, 4]
    B[band(2)] .= [5, 6, 7, 8]
    B′ = op(B)
    rowind′, colind′ = ArrayInterface.findstructralnz(B′)
    rowind′′, colind′′ = ArrayInterface.findstructralnz(BandedMatrix(B′))
    @test checkequal(rowind′, rowind′′)
    @test checkequal(colind′, colind′′)

    @test ArrayInterface.isstructured(typeof(B′))
    @test ArrayInterface.fast_matrix_colors(typeof(B′))

    @test ArrayInterface.matrix_colors(B′) == ArrayInterface.matrix_colors(BandedMatrix(B′))
end

using ArrayInterface
using Documenter

makedocs(;
    modules=[ArrayInterface],
    sitename="ArrayInterface.jl",
    pages=[
        "ArrayInterface.jl: An Extended Array Interface for Julia Generic Programming" => "index.md",
        "indexing.md",
        "conversions.md",
        "linearalgebra.md",
        "sparsearrays.md",
        "tuples.md",
        "wrapping.md",
    ]
)

deploydocs(;
    repo="github.com/JuliaArrays/ArrayInterface.jl"
)

using StaticArrays, ArrayInterface, Test
using LinearAlgebra
using ArrayInterface: undefmatrix, zeromatrix

x = @SVector [1,2,3]
@test ArrayInterface.ismutable(x) == false
@test ArrayInterface.ismutable(view(x, 1:2)) == false
@test ArrayInterface.can_setindex(typeof(x)) == false
@test ArrayInterface.buffer(x) == x.data

x = @MVector [1,2,3]
@test ArrayInterface.ismutable(x) == true
@test ArrayInterface.ismutable(view(x, 1:2)) == true
@test ArrayInterface.can_setindex(typeof(x)) == true

A = @SMatrix(randn(5, 5))
@test ArrayInterface.lu_instance(A) isa typeof(lu(A))
A = @MMatrix(randn(5, 5))
@test ArrayInterface.lu_instance(A) isa typeof(lu(A))

x = @SMatrix rand(Float32, 2, 2)
y = @SVector rand(4)
yr = ArrayInterface.restructure(x, y)
@test yr isa SMatrix{2, 2}
@test Base.size(yr) == (2,2)
@test vec(yr) == vec(y)
z = rand(4)
zr = ArrayInterface.restructure(x, z)
@test zr isa SMatrix{2, 2}
@test Base.size(zr) == (2,2)
@test vec(zr) == vec(z)


@testset "zeromatrix and unsafematrix" begin
    for T in (Int, Float32, Float64)
        for (vectype, mattype) in ((SVector{4,T},     SMatrix{4,4,T,16}),
                                   (MVector{4,T},     MMatrix{4,4,T,16}),
                                   (SMatrix{2,2,T,4}, SMatrix{4,4,T,16}),
                                   (MMatrix{2,2,T,4}, MMatrix{4,4,T,16}))
            v = vectype(rand(T, 4))
            um = undefmatrix(v)
            @test typeof(um) == mattype
            @test zeromatrix(v) == zeros(T,length(v),length(v))
        end
    end
end

module ArrayInterfaceSparseArraysExt

import ArrayInterface: buffer, has_sparsestruct, issingular, findstructralnz, bunchkaufman_instance, DEFAULT_CHOLESKY_PIVOT, cholesky_instance, ldlt_instance, lu_instance, qr_instance
using ArrayInterface.LinearAlgebra
using SparseArrays

buffer(x::SparseMatrixCSC) = getfield(x, :nzval)
buffer(x::SparseVector) = getfield(x, :nzval)
has_sparsestruct(::Type{<:SparseMatrixCSC}) = true
issingular(A::AbstractSparseMatrix) = !issuccess(lu(A, check = false))

function findstructralnz(x::SparseMatrixCSC)
    rowind, colind, _ = findnz(x)
    (rowind, colind)
end

function bunchkaufman_instance(A::SparseMatrixCSC{Tv, Ti}) where {Tv, Ti}
    bunchkaufman(SparseMatrixCSC{Tv, Ti}(similar(A, 1, 1)), check = false)
end

function cholesky_instance(A::Union{SparseMatrixCSC{Tv, Ti},Symmetric{<:Number,<:SparseMatrixCSC{Tv, Ti}}}, pivot = DEFAULT_CHOLESKY_PIVOT) where {Tv, Ti}
    cholesky(SparseMatrixCSC{Tv, Ti}(similar(A, 1, 1)), check = false)
end

function ldlt_instance(A::SparseMatrixCSC{Tv, Ti}) where {Tv, Ti}
    ldlt(SparseMatrixCSC{Tv, Ti}(similar(A, 1, 1)), check=false)
end

# Could be optimized but this should work for any real case.
function lu_instance(jac_prototype::SparseMatrixCSC{Tv, Ti}, pivot = DEFAULT_CHOLESKY_PIVOT) where {Tv, Ti}
    lu(SparseMatrixCSC{Tv, Ti}(rand(1,1)))
end

function qr_instance(jac_prototype::SparseMatrixCSC{Tv, Ti}, pivot = DEFAULT_CHOLESKY_PIVOT) where {Tv, Ti}
    qr(SparseMatrixCSC{Tv, Ti}(rand(1,1)))
end

end

using CUDSS, CUDA, SparseArrays, LinearAlgebra
using CUDA.CUSPARSE
using ArrayInterface

using Test

A_cpu = Float32[1 0; 0 1]
A_dense = CuMatrix(A_cpu)
A_sparse = CuSparseMatrixCSR(sparse(A_cpu))

# Test whether lu_instance throws an error when invoked with an gpu array
lu_inst_dense = ArrayInterface.lu_instance(A_dense)
lu_inst_sparse = ArrayInterface.lu_instance(A_sparse)

# test that lu! is valid when using the inst as scratch
lu_sparse = lu!(lu_inst_sparse, A_sparse)

#test that the resulting lu works
b = CuVector([1f0, 1f0])
@test CUDA.@allowscalar lu_sparse \ b == [1, 1]

module ArrayInterfaceGPUArraysCoreExt

using Adapt
using ArrayInterface
import LinearAlgebra
import GPUArraysCore

ArrayInterface.fast_scalar_indexing(::Type{<:GPUArraysCore.AbstractGPUArray}) = false
@inline ArrayInterface.allowed_getindex(x::GPUArraysCore.AbstractGPUArray, i...) = GPUArraysCore.@allowscalar(x[i...])
@inline ArrayInterface.allowed_setindex!(x::GPUArraysCore.AbstractGPUArray, v, i...) = (GPUArraysCore.@allowscalar(x[i...] = v))

function Base.setindex(x::GPUArraysCore.AbstractGPUArray, v, i::Int)
    _x = copy(x)
    ArrayInterface.allowed_setindex!(_x, v, i)
    return _x
end

function ArrayInterface.restructure(x::GPUArraysCore.AbstractGPUArray, y)
    reshape(Adapt.adapt(ArrayInterface.parameterless_type(x), y), Base.size(x)...)
end

# Build the `LU` directly rather than calling `lu` on an adapted array, matching the CPU
# methods in ArrayInterface.jl. Going through `lu` only works for backends that define their
# own, so it breaks on JLArrays (which downstream packages use to test GPU paths without a
# GPU) and on Metal, see #501 and #467.
function ArrayInterface.lu_instance(A::GPUArraysCore.AbstractGPUMatrix{T}) where {T}
    noUnitT = typeof(zero(T))
    luT = LinearAlgebra.lutype(noUnitT)
    ipiv = similar(A, LinearAlgebra.BlasInt, 0)
    info = zero(LinearAlgebra.BlasInt)
    return LinearAlgebra.LU{luT}(similar(A, 0, 0), ipiv, info)
end

# Doesn't do much, but makes a gigantic change to the dependency chain.
# ArrayInterface.device(::Type{<:GPUArraysCore.AbstractGPUArray}) = ArrayInterface.GPU()

end

using ArrayInterface
using BlockBandedMatrices
using FillArrays
using Test

BB=BlockBandedMatrix(Ones(10,10),[1,2,3,4],[4,3,2,1],(1,0))
BB[BlockBandedMatrices.Block(1,1)].=[1 2 3 4]
BB[BlockBandedMatrices.Block(2,1)].=[5 6 7 8;9 10 11 12]
rowind,colind=ArrayInterface.findstructralnz(BB)
@test [BB[rowind[i],colind[i]] for i in 1:length(rowind)]==
    [1,5,9,2,6,10,3,7,11,4,8,12,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1]
@test ArrayInterface.isstructured(typeof(BB))
@test ArrayInterface.has_sparsestruct(typeof(BB))
@test ArrayInterface.fast_matrix_colors(typeof(BB))

dense=collect(Ones(8,8))
for i in 1:8
    dense[:,i].=[1,2,3,4,5,6,7,8]
end
BBB=BandedBlockBandedMatrix(dense, [4, 4] ,[4, 4], (1, 1), (1, 1))
rowind,colind=ArrayInterface.findstructralnz(BBB)
@test [BBB[rowind[i],colind[i]] for i in 1:length(rowind)]==
    [1,2,3,1,2,3,4,2,3,4,5,6,7,5,6,7,8,6,7,8,
     1,2,3,1,2,3,4,2,3,4,5,6,7,5,6,7,8,6,7,8]
@test ArrayInterface.isstructured(typeof(BBB))
@test ArrayInterface.has_sparsestruct(typeof(BBB))
@test ArrayInterface.fast_matrix_colors(typeof(BBB))

module ArrayInterfaceCUDAExt

using ArrayInterface
using CUDA
using CUDA.CUSOLVER
using CUDA.CUSPARSE
using LinearAlgebra

function ArrayInterface.lu_instance(A::CuMatrix{T}) where {T}
    ipiv = cu(Vector{Int32}(undef, 0))
    info = zero(Int)
    return LinearAlgebra.LU(similar(A, 0, 0), ipiv, info)
end

ArrayInterface.device(::Type{<:CUDA.CuArray}) = ArrayInterface.GPU()

# CUSPARSE arrays implement no `setindex!` at all, so the `true` default is wrong
# for them and callers guarding mutation with `can_setindex` hit a CanonicalIndexError.
const CuSparseArray = Union{
    CUSPARSE.CuSparseVector,
    CUSPARSE.CuSparseMatrixCSC,
    CUSPARSE.CuSparseMatrixCSR,
    CUSPARSE.CuSparseMatrixBSR,
    CUSPARSE.CuSparseMatrixCOO,
}
ArrayInterface.can_setindex(::Type{<:CuSparseArray}) = false

# GPU CSC/CSR do not subtype `SparseArrays.AbstractSparseMatrixCSC`, so they need their own
# structure comparison. The stored index arrays are `CuVector`s; `==` reduces on-device.
function ArrayInterface.same_sparsity_structure(
        A::CUSPARSE.CuSparseMatrixCSC, B::CUSPARSE.CuSparseMatrixCSC
    )
    size(A) == size(B) && A.colPtr == B.colPtr && A.rowVal == B.rowVal
end
function ArrayInterface.same_sparsity_structure(
        A::CUSPARSE.CuSparseMatrixCSR, B::CUSPARSE.CuSparseMatrixCSR
    )
    size(A) == size(B) && A.rowPtr == B.rowPtr && A.colVal == B.colVal
end

function ArrayInterface.promote_eltype(
        ::Type{<:CUDA.CuArray{T, N, M}}, ::Type{T2}
    ) where {T, N, M, T2}
    return CUDA.CuArray{promote_type(T, T2), N, M}
end

end # module

using ArrayInterface, ChainRules, Test
using ComponentArrays, ChainRulesTestUtils, StaticArrays

x = ChainRules.OneElement(3.0, (3, 3), (1:4, 1:4))

@test !ArrayInterface.can_setindex(x)
@test !ArrayInterface.can_setindex(typeof(x))

arr = ComponentArray(a = 1.0, b = [2.0, 3.0], c = (; a = 4.0, b = 5.0), d = SVector{2}(6.0, 7.0))
b = zeros(length(arr))

ChainRulesTestUtils.test_rrule(ArrayInterface.restructure, arr, b)
ChainRulesTestUtils.test_rrule(ArrayInterface.restructure, b, arr)

using SafeTestsets, Pkg

const GROUP = get(ENV, "GROUP", "All")

function activate_gpu_env()
    Pkg.activate("gpu")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    Pkg.instantiate()
end

@time begin
    if GROUP == "All" || GROUP == "Core"
        @time @safetestset "BandedMatrices" begin include("bandedmatrices.jl") end
        @time @safetestset "BlockBandedMatrices" begin include("blockbandedmatrices.jl") end
        @time @safetestset "Core" begin include("core.jl") end
        @time @safetestset "AD Integration" begin include("ad.jl") end
        @time @safetestset "StaticArrays" begin include("staticarrays.jl") end
        @time @safetestset "ChainRules" begin include("chainrules.jl") end
    end

    if GROUP == "GPU"
        activate_gpu_env()
        @time @safetestset "CUDA" begin include("gpu/cuda.jl") end
        if Sys.isapple()
            @time @safetestset "Metal" begin include("gpu/metal.jl") end
        end
    end
end

module ArrayInterfaceMetalExt

using ArrayInterface
using Metal
using LinearAlgebra

function ArrayInterface.lu_instance(A::MtlMatrix{T}) where {T}
    ipiv = MtlVector{Int32}(undef, 0)
    info = zero(Int)
    return LinearAlgebra.LU(similar(A, 0, 0), ipiv, info)
end

ArrayInterface.device(::Type{<:Metal.MtlArray}) = ArrayInterface.GPU()

function ArrayInterface.promote_eltype(
        ::Type{<:Metal.MtlArray{T, N, S}}, ::Type{T2}
    ) where {T, N, S, T2}
    return Metal.MtlArray{promote_type(T, T2), N, S}
end

end # module

module ArrayInterfaceCUDSSExt

using ArrayInterface
using CUDSS
using CUDA

function ArrayInterface.lu_instance(A::CUDSS.CuSparseMatrixCSR)
    ArrayInterface.LinearAlgebra.checksquare(A)
    T = eltype(A)
    n = size(A, 1)

    # Use standard CUDA types (CuVector) instead of deprecated CudssMatrix
    x = CUDA.CuVector{T}(undef, n)
    b = CUDA.CuVector{T}(undef, n)

    fact = CudssSolver(A, "G", 'F')
    cudss("analysis", fact, x, b)
    fact
end

end

module ArrayInterfaceGPUArraysCoreTrackerExt

using Adapt
using ArrayInterface
import GPUArraysCore
import Tracker

# Tracker.adapt_structure uses `param(adapt(T, data(xs)))`, which severs the tape.
function _adapt_tracked_storage(T, y)
    Adapt.adapt(T, y)
end
function _adapt_tracked_storage(T, y::Tracker.TrackedArray)
    Tracker.track(_adapt_tracked_storage, T, y)
end
Tracker.@grad function _adapt_tracked_storage(T, y)
    ydata = Tracker.data(y)
    Adapt.adapt(T, ydata),
    Δ -> (nothing, Adapt.adapt(ArrayInterface.parameterless_type(ydata), Tracker.data(Δ)))
end

function ArrayInterface.restructure(
        x::GPUArraysCore.AbstractGPUArray, y::Tracker.TrackedArray)
    T = ArrayInterface.parameterless_type(x)
    yT = Tracker.data(y) isa T ? y : _adapt_tracked_storage(T, y)
    reshape(yT, Base.size(x)...)
end

end

module ArrayInterfaceAMDGPUExt

using ArrayInterface
using AMDGPU
using LinearAlgebra

function ArrayInterface.lu_instance(A::ROCMatrix{T}) where {T}
    ipiv = ROCVector{Cint}(undef, 0)
    info = zero(Int)
    return LinearAlgebra.LU(similar(A, 0, 0), ipiv, info)
end

ArrayInterface.device(::Type{<:AMDGPU.ROCArray}) = ArrayInterface.GPU()

function ArrayInterface.promote_eltype(
        ::Type{<:AMDGPU.ROCArray{T, N, B}}, ::Type{T2}
    ) where {T, N, B, T2}
    return AMDGPU.ROCArray{promote_type(T, T2), N, B}
end

end # module

using ArrayInterface, FillArrays, Test

@test !ArrayInterface.can_setindex(Fill(1.0, 3))
@test !ArrayInterface.can_setindex(typeof(Fill(1.0, 3)))
@test !ArrayInterface.can_setindex(Ones(3))
@test !ArrayInterface.can_setindex(Zeros(3))
@test !ArrayInterface.can_setindex(typeof(Zeros(2, 2)))

oe = OneElement(3.0, 2, 4)
@test !ArrayInterface.can_setindex(oe)
@test !ArrayInterface.can_setindex(typeof(oe))

using ArrayInterface, ReverseDiff, Tracker, Test, JLArrays
x = ReverseDiff.track([4.0])
@test ArrayInterface.aos_to_soa(x) isa ReverseDiff.TrackedArray
x = reshape([ReverseDiff.track(rand(1, 1, 1))[1]], 1, 1, 1)
@test ArrayInterface.aos_to_soa(x) isa ReverseDiff.TrackedArray
@test ndims(ArrayInterface.aos_to_soa(x)) == 3
x = reduce(vcat, ReverseDiff.track([4.0, 4.0]))
@test ArrayInterface.aos_to_soa(x) isa ReverseDiff.TrackedArray
x = [ReverseDiff.track([4.0])[1]]
@test ArrayInterface.aos_to_soa(x) isa ReverseDiff.TrackedArray
x = reduce(vcat, ReverseDiff.track([4.0, 4.0]))
x = [x[1], x[2]]
@test ArrayInterface.aos_to_soa(x) isa ReverseDiff.TrackedArray

x = Tracker.TrackedArray([4.0])
@test ArrayInterface.aos_to_soa(x) isa Tracker.TrackedArray
x = [Tracker.TrackedArray([4.0])[1]]
@test ArrayInterface.aos_to_soa(x) isa Tracker.TrackedArray
x = Tracker.TrackedArray([4.0, 4.0])
@test ArrayInterface.aos_to_soa(x) isa Tracker.TrackedArray
x = reduce(vcat, Tracker.TrackedArray([4.0, 4.0]))
x = [x[1], x[2]]
@test ArrayInterface.aos_to_soa(x) isa Tracker.TrackedArray

x = rand(4)
y = Tracker.TrackedReal.(rand(2, 2))
@test ArrayInterface.restructure(x, y) isa Array
@test eltype(ArrayInterface.restructure(x, y)) <: Tracker.TrackedReal
@test size(ArrayInterface.restructure(x, y)) == (4,)
y = Tracker.TrackedArray(rand(2, 2))
@test ArrayInterface.restructure(x, y) isa Tracker.TrackedArray
@test size(ArrayInterface.restructure(x, y)) == (4,)
x = Tracker.TrackedArray(rand(4))
@test ArrayInterface.restructure(x, y) isa Tracker.TrackedArray
@test size(ArrayInterface.restructure(x, y)) == (4,)
y = Tracker.TrackedReal.(rand(2, 2))
@test ArrayInterface.restructure(x, y) isa Tracker.TrackedArray
@test size(ArrayInterface.restructure(x, y)) == (4,)

x = rand(4)
y = ReverseDiff.track(rand(2, 2))
@test ArrayInterface.restructure(x, y) isa ReverseDiff.TrackedArray
@test size(ArrayInterface.restructure(x, y)) == (4,)
x = ReverseDiff.track(rand(4))
@test ArrayInterface.restructure(x, y) isa ReverseDiff.TrackedArray
@test size(ArrayInterface.restructure(x, y)) == (4,)
y = ReverseDiff.track.(rand(2, 2))
@test ArrayInterface.restructure(x, y) isa ReverseDiff.TrackedArray
@test size(ArrayInterface.restructure(x, y)) == (4,)
x = rand(4)
@test ArrayInterface.restructure(x, y) isa Array
@test eltype(ArrayInterface.restructure(x, y)) <: ReverseDiff.TrackedReal
@test size(ArrayInterface.restructure(x, y)) == (4,)

@testset "restructure GPUArraysCore + Tracker" begin
    target = JLArray(reshape(Float32.(1:6), 2, 3))
    src = JLArray(copy(vec(Array(target))))
    src_cpu = Array(src)

    yr = ArrayInterface.restructure(target, src)
    @test yr isa JLArray
    @test size(yr) == (2, 3)
    @test Array(yr) == reshape(Array(src), 2, 3)

    y, back = Tracker.forward(src) do t
        r = ArrayInterface.restructure(target, t)
        @test Tracker.data(r) isa JLArray
        @test size(r) == (2, 3)
        sum(r)
    end
    dx = only(back(1.0f0))
    @test Tracker.data(y) == 21.0f0
    @test Array(Tracker.data(dx)) == ones(Float32, 6)

    y_cpu, back_cpu = Tracker.forward(src_cpu) do t
        r = ArrayInterface.restructure(target, t)
        @test Tracker.data(r) isa JLArray
        @test size(r) == (2, 3)
        sum(r)
    end
    dx_cpu = only(back_cpu(1.0f0))
    @test Tracker.data(y_cpu) == 21.0f0
    @test dx_cpu == ones(Float32, 6)
end

# Julia's Extended Sparse Array Interface

The following ArrayInterface functions extend Julia's Base LinearAlgebra interface
to improve the ability to do sparse linear algebra.

## Sparse Indexing

These routines allow for improving sparse iteration and indexing.

```@docs
ArrayInterface.isstructured
ArrayInterface.findstructralnz
ArrayInterface.has_sparsestruct
```

## Matrix Coloring

Many routines require calculating the coloring of a matrix, such as for sparse
differentation. The `matrix_colors` function is the high level function which
returns a color vector `Vector{Int}` with the column colors. This function
is overloaded for many special matrix types with analytical solutions for the
matrix colors.

```@docs
ArrayInterface.fast_matrix_colors
ArrayInterface.matrix_colors
```

### General Matrix Colors

For the general dispatch of `matrix_colors`, see [SparseDiffTools.jl](https://github.com/JuliaDiff/SparseDiffTools.jl)
for a full graph-based coloring algorithm which extends ArrayInterface.

## Addtional Sparse Array Interface Tools

If dealing with general sparse arrays, consider:

- [SparseDiffTools.jl](https://github.com/JuliaDiff/SparseDiffTools.jl): A general set of tools for extending calculus libraries for sparse optimizations.
- [LinearSolve.jl](https://github.com/SciML/LinearSolve.jl): An extended linear solving library with support for generic sparse arrays.

# Julia's Extended Array Indexing Interface

The following ArrayInterface functions extend Julia's Base LinearAlgebra interface
to improve the ability to write code for generic array types.

## Indexing Traits

The following traits allow for one to accurately determine the type of indexing allowed
on arrays in order to write optimal code for generic array types.

```@docs
ArrayInterface.can_avx
ArrayInterface.can_change_size
ArrayInterface.can_setindex
ArrayInterface.fast_scalar_indexing
ArrayInterface.ismutable
ArrayInterface.ndims_index
ArrayInterface.ndims_shape
ArrayInterface.defines_strides
ArrayInterface.ensures_all_unique
ArrayInterface.ensures_sorted
ArrayInterface.indices_do_not_alias
ArrayInterface.instances_do_not_alias
ArrayInterface.device
```

## Allowed Indexing Functions

These are generic functions for forced "allowed indexing". For example, with CUDA.jl's
CuArrays a mode can be enabled such that `allowscalar(false)` forces errors to be thrown
if a GPU array is scalar indexed. Instead of using the CUDA-specific `CUDA.@allowscalar`
on an operation, these functions allow for a general generic "allowed indexing" for all
array types.

```@docs
ArrayInterface.allowed_getindex
ArrayInterface.allowed_setindex!
```

## Indexing Type Buffers

The following indexing types allow for generically controlling bounds checking
and index translations.

```@docs
ArrayInterface.ArrayIndex
ArrayInterface.GetIndex
ArrayInterface.SetIndex!
```

# Julia's Array Wrapping Interface

The following functions make it easier to handle array wrappers, such as `Adjoint`, which
can obscure an underlying array's properties under a layer of indirection.

```@docs
ArrayInterface.is_forwarding_wrapper
ArrayInterface.buffer
ArrayInterface.parent_type
```

## Additional Array Wrapping Libraries

If dealing with array wrappers, additionally consider:

- [Adapt.jl](https://github.com/JuliaGPU/Adapt.jl): conversions for handling device (GPU) wrappers.

# Julia's Extended Linear Algebra Interface

The following ArrayInterface functions extend Julia's Base LinearAlgebra interface
to improve the ability to do generic linear algebra.

## Generic Matrix Constructors

These functions allow for the construction of matrices from array information in a generic
way. It handles cases like how if `x` is a vector on the GPU, its associated matrix type
should also be GPU-based, and thus appropriately placed with zeros/undef values.

```@docs
ArrayInterface.zeromatrix
ArrayInterface.undefmatrix
```

## Generic Matrix Functions

These query allow for easily learning properties of a general matrix.

```@docs
ArrayInterface.issingular
```

## Factorization Instance Functions 

These functions allow for generating the instance of a factorization's result without
running the full factorization. This thus allows for building types to hold the factorization
without having to perform expensive extra computations.

```@docs
ArrayInterface.bunchkaufman_instance
ArrayInterface.cholesky_instance
ArrayInterface.ldlt_instance
ArrayInterface.lu_instance
ArrayInterface.qr_instance
ArrayInterface.svd_instance
```

## Addtional Linear Algebra Interface Tools

If dealing with general linear algebra, consider:

- [LinearSolve.jl](https://github.com/SciML/LinearSolve.jl): An extended linear solving library with support for generic arrays.

```@meta
CurrentModule = ArrayInterface
```
# ArrayInterface

Designs for new Base array interface primitives, used widely through scientific machine learning (SciML) and other organizations

## Extensions

ArrayInterface.jl uses extension packages in order to add support for popular libraries to its interface functions. These packages are:

- BandedMatrices.jl
- BlockBandedMatrices.jl
- GPUArrays.jl / CUDA.jl
- OffsetArrays.jl
- Tracker.jl

## StaticArrayInterface.jl

If one is looking for an interface which includes functionality for statically-computed values, see
[StaticArrayInterface.jl](https://github.com/JuliaArrays/StaticArrayInterface.jl).
This was separated from ArrayInterface.jl because it includes a lot of functionality that does not give substantive improvements
to the interface, and is likely to be deprecated in the near future as the compiler matures to automate a lot of its optimizations.

# Julia's Extended Array Conversions Interface

The following ArrayInterface functions extend Julia's Array interface for how arrays
can be converted to different forms.

## Conversion Functions

```@docs
ArrayInterface.aos_to_soa
ArrayInterface.promote_eltype
ArrayInterface.restructure
ArrayInterface.safevec
ArrayInterface.has_trivial_array_constructor
```
